                      Computer Science 825
                           Quiz 8          Name _______________________

1. Show how a sliding window protocol that uses a 3 bit sequence
   number, a sender window size of 6, and a receiver window size of 3
   can fail.















2. Suppose that a satellite channel is in use and the EARTH to SATELLITE
   propogation delay is 120 ms.  Suppose bit transmission rate is 200,000
   bits per second and packets are 4000 bits long.

   a. What will the efficiency of this channel be if stop and wait
      protocal is used.



   b. How large (in packets) must the SWS be in order to obtain 100%
      efficiency if the channel is guaranteed error free. (i.e. give
      me the MINIMUM SWS I can use).




   c. How large (in packets) must the RWS be in order to obtain 100%
      efficiency if the channel is guaranteed error free. (i.e. give
      me the MINIMUM RWS I can use).




   d. How many bits will be required in the sequence if the selective
      reject sliding window protocol is used and 100% utilization is
      to be achieved in the absence of errors.





4. For each of the following combinations of propogation delay
   and error rate identify the most suitable variation of sliding
   window protocol. (The most suitable choice is the SIMPLEST
   one that doesn't incur a big performance penalty.)

   ___ a. No errors but very long     1. Stop and Wait
          propogation delay
   ___ b. No errors and negligable    2. Go back N
          propogation delay.
   ___ c. High errors and very long   3. Selective repeat
          propogation delay
                                      4. Selective reject.


5. Identify two deficiencies of the protocol 5 implementation that
   would HAVE TO BE corrected before it could be successfully used
   in a real network.

   a.



   b.

6. A buffer in the protocol discussed in class cycled though a number
   of queues.. Associate each transition with the process that
   caused it. (Some answers may be used more than once or not at all).

      ____ 1. Read pending to network      a.  Writelink process
              input.

      ____ 2. Network input to link        b.  Readlink process
              station output
                                           c.  Timeout process
      ____ 3. Link output to
              sender window.               d.  Network layer process

       ___ 4. Sender window to free        e.  Queuemsg process
              list

7. The protocol discussed in class became deadlocked when

   a. Any readlink process became       b. All readlink processes became
      blocked in dequeue.                  blocked in dequeue,

   c. Any time an ACK was lost          d. Never

8. The sender window logic used three indexes: nxtsend; nxtqueue; and
   nxtack. We said these values always remained in a specific relative
   order. The order was

   a. send <= queue <= ack              b. queue <= ack <= send

   c. ack <= queue <= send              d. ack <= send <= queue

